// M Hentz, 2016

#ifndef DetectorMessenger_h
#define DetectorMessenger_h 1

#include "globals.hh"
#include "G4UImessenger.hh"

class DetectorConstruction;
class G4UIdirectory;
class G4UIcommand;
class G4UIcmdWithAString;
class G4UIcmdWith3VectorAndUnit;
class G4UIcmdWithAnInteger;
class G4UIcmdWithADoubleAndUnit;
class G4UIcmdWithoutParameter;

class DetectorMessenger: public G4UImessenger
{
public:
  DetectorMessenger( DetectorConstruction* );
  ~DetectorMessenger();

  virtual void SetNewValue(G4UIcommand*, G4String);

private:
  DetectorConstruction*      fDetector;
  G4UIdirectory*             fSimDir;
  G4UIdirectory*             fDetDir;
  G4UIcmdWithAString*        fMatCmd;
  G4UIcmdWith3VectorAndUnit* fPosCmd;
  G4UIcmdWithADoubleAndUnit* fSizeZCmd;
  G4UIcmdWithADoubleAndUnit* fSizeXYCmd;
  G4UIcmdWithADoubleAndUnit* fLayerSizeXYCmd;
  G4UIcmdWithAnInteger*      fLayerNumberCmd;
  G4UIcmdWithoutParameter*   fUpdateCmd;
};

#endif

