// M Hentz, 2016

#ifndef EventAction_h
#define EventAction_h 1

#include "G4UserEventAction.hh"
#include "globals.hh"
#include "G4ios.hh"

#include "PhaseSpaceHit.hh"
#include "RunAction.hh"

class EventActionMessenger;

class EventAction : public G4UserEventAction
{
public:
  EventAction();
  ~EventAction();

public:
  virtual void   BeginOfEventAction( const G4Event* );
  virtual void   EndOfEventAction( const G4Event* );

  void SetDrawFlag( G4String val ) { fDrawFlag = val; }
  void SetPrintModulo( G4int val ) { fPrintModulo = val; }

private:
  G4String               fDrawFlag;
  G4int                  fPrintModulo;
  EventActionMessenger*  fEventMessenger;
  G4int                  fEventID;
};

#endif
