#ifndef PhaseSpaceSD_h
#define PhaseSpaceSD_h 1

#include "G4VSensitiveDetector.hh"
#include "PhaseSpaceHit.hh"
#include "RunAccumulator.hh"

class G4Step;
class G4HCofThisEvent;
class G4TouchableHistory;

class PhaseSpaceSD : public G4VSensitiveDetector
{
public:
  PhaseSpaceSD( G4String );
  virtual ~PhaseSpaceSD();
  
  virtual G4bool ProcessHits( G4Step* step, G4TouchableHistory* ROhist );

  virtual G4int GetNoOfCopies() { return fNoOfCopies; }
  
  virtual void Initialize( G4HCofThisEvent* HCE );
  virtual void EndOfEvent( G4HCofThisEvent* );
  
  virtual void clear();
  virtual void DrawAll();
  virtual void PrintAll();
  
private:
  PhaseSpaceHitsCollection* fHitsCollection;
  G4int   fNoOfCopies;
  
};

#endif
