// M Hentz, 2016

#ifndef SteppingAction_h
#define SteppingAction_h 1

#include "G4UserSteppingAction.hh"
#include "G4VProcess.hh"

class DetectorConstruction;
class RunAction;
class SteppingActionMessenger;

class SteppingAction : public G4UserSteppingAction
{
public:
  SteppingAction( DetectorConstruction*, RunAction* );
  virtual ~SteppingAction();
  
  virtual void UserSteppingAction( const G4Step* );

  void SetKillPosition( G4double killPosition ) { fKillPosition = killPosition; }
  
private:
  DetectorConstruction*     fDetector;
  RunAction*                fRunAction;
  SteppingActionMessenger*  fSteppingActionMessenger;
  G4double                  fKillPosition;
  
};

#endif
