// M Hentz, 2016

#include "G4Event.hh"
#include "G4EventManager.hh"

#include "EventAction.hh"
#include "EventActionMessenger.hh"

EventAction::EventAction()
    :G4UserEventAction(),fDrawFlag("none"),fPrintModulo(10000)
{
  fEventMessenger = new EventActionMessenger(this);
}

EventAction::~EventAction()
{ delete fEventMessenger; }

void EventAction::BeginOfEventAction( const G4Event* evt )
{
  fEventID = evt->GetEventID();

  if ( fEventID % fPrintModulo == 0 ) {
    G4cout << "\n---> Begin of event: " << fEventID << G4endl;
  }
}

void EventAction::EndOfEventAction( const G4Event* )
{;}
