// M Hentz, 2016

#include "StepMaxMessenger.hh"
#include "StepMax.hh"
#include "G4UIcmdWithADoubleAndUnit.hh"

StepMaxMessenger::StepMaxMessenger( StepMax* stepMax )
    :G4UImessenger(),
     fStepMax(stepMax),
     fStepMaxCmd(0)
{
  fStepMaxCmd = new G4UIcmdWithADoubleAndUnit( "/cb_sim/stepMax", this );
  fStepMaxCmd->SetGuidance( "Set max allowed step length" );
  fStepMaxCmd->SetParameterName( "maxStep", false );
  fStepMaxCmd->SetRange( "maxStep > 0." );
  fStepMaxCmd->SetUnitCategory( "Length" );
}

StepMaxMessenger::~StepMaxMessenger()
{
  delete fStepMaxCmd;
}

void StepMaxMessenger::SetNewValue( G4UIcommand* command, G4String newValue )
{ 
  if ( command == fStepMaxCmd )
    { fStepMax->SetMaxStep( fStepMaxCmd->GetNewDoubleValue( newValue ) ); }
}


